<?php
/* CLASS: Post Display */

class vcmegaposts_post_display_class {
    function __construct() {
        add_action( 'init', array( $this, 'integrate_vcmegaposts_post_displayWithVC' ) );
        add_shortcode( 'vcmp_post_display', array( $this, 'vcmegaposts_post_display_function' ) );
        add_action( 'wp_enqueue_scripts', array( $this, 'vcmegaposts_post_display_loadCssAndJs' ) );
    }
 
    public function integrate_vcmegaposts_post_displayWithVC() {
        if ( ! defined( 'WPB_VC_VERSION' ) ) {
            return;
        }

		include('animate-list.php');
		
		vc_map( array(
            "name" => __("MP Post Display", 'vcmegaposts'),
            "description" => __("Add your Post Display", 'vcmegaposts'),
            "base" => "vcmp_post_display",
            "class" => "adtheme",
            "controls" => "full",
            "icon" => plugins_url('vcmegaposts/assets/img/vcmegaposts_icon.png'),
            "category" => __('VC Mega Posts', 'js_composer'),
            "params" => array(	
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Post Display Type", 'vcmegaposts'),
                  "param_name" => "vcmp_post_display_type",
                  "value" => array(
				  					__('Post Display Type 1','vcmegaposts') => 'posts_type1',
									__('Post Display Type 2','vcmegaposts') => 'posts_type2',
									__('Post Display Type 3','vcmegaposts') => 'posts_type3',
									__('Post Display Type 4','vcmegaposts') => 'posts_type4',	
									__('Post Display Type 5','vcmegaposts') => 'posts_type5',																																			
				   ),			   
				),			


				// post_display TYPE 1
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Excerpt", 'vcmegaposts'),
                  "param_name" => "vcmp_post_display_excerpt",
                  "value" => array(
				  					__('Show','vcmegaposts') 		=> 'true',
									__('Hidden','vcmegaposts')  		=> 'false',
				   ),			   				   			   
				),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Number Experpt",'vcmegaposts'),
				  "param_name" => "vcmp_post_display_excerpt_number",
				  "description" => "ex 50. Leave empty for default value",				  
				  "dependency" => array(
							'element' => 'vcmp_post_display_excerpt',
							'value' => array( 'true' )
				  ),					  				  			  				  
			    ),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Date", 'vcmegaposts'),
                  "param_name" => "vcmp_post_display_date",
                  "value" => array(
				  					__('Show','vcmegaposts') 			=> 'true',
									__('Hidden','vcmegaposts')  		=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Date Format", 'vcmegaposts'),
                  "param_name" => "vcmp_post_display_date_format",
                  "value" => array(
				  					__('November 6, 2010 12:50 am','vcmegaposts') 		=> 'F j, Y g:i a',
									__('November 6, 2010','vcmegaposts')  				=> 'F j, Y',
				  					__('November, 2010','vcmegaposts') 					=> 'F, Y',
									__('12:50 am','vcmegaposts')  						=> 'g:i a',
				  					__('12:50:48 am','vcmegaposts') 						=> 'g:i:s a',
									__('Saturday, November 6th, 2010','vcmegaposts')  	=> 'l, F jS, Y',
				  					__('Nov 6, 2010 @ 0:50','vcmegaposts') 				=> 'M j, Y @ G:i',
									__('2010/11/06 at 12:50 AM','vcmegaposts')  			=> 'Y/m/d \a\t g:i A',
				  					__('2010/11/06 at 12:50am','vcmegaposts') 			=> 'Y/m/d \a\t g:ia',
									__('2010/11/06 12:50:48 AM','vcmegaposts')  			=> 'Y/m/d g:i:s A',
									__('2010/11/06','vcmegaposts')  						=> 'Y/m/d',																																														
				   ),
				  "dependency" => array(
							'element' => 'vcmp_post_display_date',
							'value' => array( 'true' )
					),					   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Comments", 'vcmegaposts'),
                  "param_name" => "vcmp_post_display_comments",
                  "value" => array(
				  					__('Show','vcmegaposts') 		=> 'true',
									__('Hidden','vcmegaposts')  		=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Author", 'vcmegaposts'),
                  "param_name" => "vcmp_post_display_author",
                  "value" => array(
				  					__('Show','vcmegaposts') 		=> 'true',
									__('Hidden','vcmegaposts')  		=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Category", 'vcmegaposts'),
                  "param_name" => "vcmp_post_display_category",
                  "value" => array(
				  					__('Show','vcmegaposts') 		=> 'true',
									__('Hidden','vcmegaposts')  		=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Views", 'vcmegaposts'),
                  "param_name" => "vcmp_post_display_views",
                  "value" => array(
				  					__('Show','vcmegaposts') 		=> 'true',
									__('Hidden','vcmegaposts')  		=> 'false',
				   ),					   			   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Columns", 'vcmegaposts'),
                  "param_name" => "columns",
                  "value" => array(
				  					__('1','vcmegaposts') 						=> '1',
									__('2','vcmegaposts')  						=> '2',
									__('3','vcmegaposts')  						=> '3',
									__('4','vcmegaposts')  						=> '4',	
									__('5','vcmegaposts')  						=> '5',	
									__('6','vcmegaposts')  						=> '6',	
									__('7','vcmegaposts')  						=> '7',	
									__('8','vcmegaposts')  						=> '8',	
									__('9','vcmegaposts')  						=> '9',																																																			
				   ),
				  "dependency" => array(
							'element' => 'vcmp_post_display_type',
							'value' => array( 'posts_type3' )
				  ),				   			   
				),	

				// QUERY 
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Source", 'vcmegaposts'),
                  "param_name" => "vcmp_query_source",
                  "value" => array(
				  					__('Wordpress Posts','vcmegaposts') 		=> 'wp_posts',
									__('Custom Posts Type','vcmegaposts')  	=> 'wp_custom_posts_type',
				   ),
				   "group" => "Query"				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("All Posts/Sticky posts", 'vcmegaposts'),
                  "param_name" => "vcmp_query_sticky_posts",
                  "value" => array(
				  					__('All Posts','vcmegaposts') 		 	=> 'allposts',
									__('Only Sticky Posts','vcmegaposts')  	=> 'onlystickyposts',
				   ),
				   "group" => "Query",
				  "dependency" => array(
							'element' => 'vcmp_query_source',
							'value' => array( 'wp_posts' )
				  ),					   				   			   
				),

			    array(
				  "type" => "posttypes", 
				  "class" => "",
				  "heading" => __("Select Post Type Source",'vcmegaposts'),
				  "param_name" => "vcmp_query_posts_type",
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'vcmp_query_source',
							'value' => array( 'wp_custom_posts_type' )
				  ),					  				  					  				  			  				  
			    ),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Categories",'vcmegaposts'),
				  "param_name" => "vcmp_query_categories",
				  "description" => "Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)",
				  "group" => "Query",					  				  					  				  			  				  
			    ),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Order", 'vcmegaposts'),
                  "param_name" => "vcmp_query_order",
                  "value" => array(
				  					__('DESC','vcmegaposts')  	=> 'DESC',
				  					__('ASC','vcmegaposts') 		=> 'ASC'
									
				   ),
				   "group" => "Query"				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Order By", 'vcmegaposts'),
                  "param_name" => "vcmp_query_orderby",
                  "value" => array(
				  					__('Date','vcmegaposts') 			=> 'date',
									__('ID','vcmegaposts')  			=> 'ID',
				  					__('Author','vcmegaposts') 			=> 'author',
									__('Title','vcmegaposts')  			=> 'title',
				  					__('Name','vcmegaposts') 			=> 'name',
									__('Modified','vcmegaposts')  		=> 'modified',
				  					__('Parent','vcmegaposts') 			=> 'parent',
									__('Rand','vcmegaposts')  			=> 'rand',
									__('Comments Count','vcmegaposts')  => 'comment_count',
									__('None','vcmegaposts')  			=> 'none',																																													
				   ),
				   "group" => "Query"				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Pagination", 'vconepage'),
                  "param_name" => "vcmp_query_pagination",
                  "value" => array(
				  					__('Yes','vconepage') 		=> 'yes',
									__('No','vconepage')  		=> 'no',
				   ),
				   "group" => "Query"				   			   
				),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Number Posts",'vconepage'),
				  "param_name" => "vcmp_query_number",
				  "description" => "ex 10",
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'vcmp_query_pagination',
							'value' => array( 'no' )
				  ),					  				  					  				  			  				  
			    ),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Pagination Type", 'vconepage'),
                  "param_name" => "vcmp_query_pagination_type",
                  "value" => array(
				  					__('Numeric','vconepage') 		=> 'numeric',
									__('Normal','vconepage')  		=> 'normal',
				  ),
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'vcmp_query_pagination',
							'value' => array( 'yes' )
				  ),				   				   			   
				),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Number Posts For Page",'vconepage'),
				  "param_name" => "vcmp_query_posts_for_page",
				  "description" => "ex 10",
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'vcmp_query_pagination',
							'value' => array( 'yes' )
				  ),					  				  					  				  			  				  
			    ),	
					  
           		/* STYLE */
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Font Type", 'vcmegaposts'),
                  "param_name" => "vcmp_font_type",
                  "value" => array(
				  					__('Default Site','vcmegaposts') 			=> 'vcmp-font-default',
									__('Google Fonts Custom','vcmegaposts')  	=> 'vcmp-google-font'
				   ),
				   "group" => "Style"				   			   
				),				
				array(
					'type' => 'google_fonts',
					'param_name' => 'vcmp_google_fonts',
					'value' => 'font_family:Abril%20Fatface%3A400|font_style:400%20regular%3A400%3Anormal',
					'settings' => array(
						'fields' => array(
							'font_family_description' => __( 'Select font family.', 'vcmegaposts' ),
							'font_style_description' => __( 'Select font styling.', 'vcmegaposts' )
						)
					),
					'dependency' => array(
							'element' => 'vcmp_font_type',
							'value' => array( 'vcmp-google-font' )
					),					
					"group" => "Style"
				),	
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Custom Style", 'vcmegaposts'),
                  "param_name" => "vcmp_custom_style",
                  "value" => array(									
									__('Off','vcmegaposts') 	  => 'off',
									__('On','vcmegaposts') => 'on'
				   ),
				   "group" => "Style"
				),									
				array(
					  "type" => "colorpicker",
					  "class" => "",
					  "heading" => __("Main Color", 'vcmegaposts'),
					  "param_name" => "vcmp_main_color",
					  "value" => '#FC615D',
					  "dependency" => array(
							'element' => 'vcmp_custom_style',
							'value' => array( 'on' )
					  ),					  
					  "group" => "Style"			  
				 ),
				  				  				  
				/* ANIMATION */  												  							  		  
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Animate", 'vcmegaposts'),
                  "param_name" => "vcmp_animate",
                  "value" => array(									
									__('Off','vcmegaposts') 	  => 'off',
									__('On','vcmegaposts') => 'on'
				   ),
				   "group" => "Animation"
				),			  
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Animate Effects", 'vcmegaposts'),
                  "param_name" => "vcmp_animate_effect",
                  "value" => $animate_effect,
				  'dependency' => array(
						'element' => 'vcmp_animate',
						'value' => array( 'on' )
				  ),
				  "group" => "Animation"				   
				),				  
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => __("Animate Delay (ms)",'vcmegaposts'),
				  "param_name" => "vcmp_delay",
				  "description" => "ex 1000",					  
				  'dependency' => array(
						'element' => 'vcmp_animate',
						'value' => array( 'on' )
				  ),
				  "value" => "0",
				  "group" => "Animation"					  
			  ),			  
			  			  
			)
		)		  			  			  			  			  			  
	  );
    }	
	
    public function vcmegaposts_post_display_loadCssAndJs() {	
		wp_register_style( 'vcmpcp-post_display',  VCMPCP_URL . 'assets/css/post_display.css' );
		wp_register_style( 'vcmpcp-owl-post_display',  VCMPCP_URL . 'assets/css/owl.post_display.css' );
		wp_register_style( 'vcmpcp-owl-theme',  VCMPCP_URL . 'assets/css/owl.theme.css' );
		wp_register_script( 'vcmpcp-owl-post_display-js',  VCMPCP_URL . 'assets/js/owl.post_display.js' , array('jquery'), '', true);
    }	
}
// Finally initialize code
new vcmegaposts_post_display_class();